#include <iostream.h>
#include <dlfcn.h>

#include "main.h"

#define LIBNAME "./libtest.so"

int main () {
  void * lib = dlopen (LIBNAME, RTLD_LAZY);
  if (!lib) {
    cout << __FUNCTION__ << ": error opening library \"" LIBNAME "\":" <<
      endl << "  " << dlerror() << endl;

    exit (1);
  }

  cout << __FUNCTION__ << ": attempting to locate g++ 3.0 symbol" << endl;
  void * func = dlsym (lib, "_Z8newclassv");
  char * err = dlerror();
  if (err) {
    cout << __FUNCTION__ << ": error locating g++ 3.0 symbol: "<<
      endl << "  " << err << endl << endl;

  cout << __FUNCTION__ << ": attempting to locate g++ 2.95 symbol" << endl;
    func = dlsym (lib, "newclass__Fv");
    err = dlerror();
    if (err) {
      cout << __FUNCTION__ << ": error locating g++ 2.95 symbol: "<<
        endl << "  " << err << endl << "  exitting" << endl;
      exit (1);
    }
  }
  cout << __FUNCTION__ << ": symbol located successfuly" << endl << endl;

// int (*pt2Function)        (float, char, char)

  A * (*pfunc) (void) = (A * (*) (void)) func;
  Aa * (*apfunc) (void) = (Aa * (*) (void)) func;


  A * a = pfunc ();
  cout << "The following should be from B::test:" << endl;
  a->test();
  cout << endl;

  Aa * aa = apfunc ();
  cout << "The following should be from B::aatest:" << endl;
  aa->aatest(5);
  cout << endl;

  delete a;
  delete aa;

  dlclose (lib);

  return 0;
}

